var WComponent_submitHandlers = new Array();
var WComponent_submitParameters = new Array();

function WComponent_error(message)
{
	alert('Internal Error:\n'
		+message+'\n\n'
		+'window: '+window.name+'\n'
		+'url: '+document.location.href);
}

/** Adds submit handler */
function WComponent_addSubmitHandler(name,param)
{
	WComponent_submitHandlers.push( name );
	WComponent_submitParameters.push( param );
}

/** Submits form checking validtion */
function WComponent_submit(validate,target)
{
	var validationResult = null;
	for(var i=0; i<WComponent_submitHandlers.length; i++)
	{
		var handler = WComponent_submitHandlers[i];
		var param = WComponent_submitParameters[i];
		var handlerFunction = eval(handler);
		var result = handlerFunction( validate, param );
		if( result != null ) 
		{
			if( validationResult == null )
			{
				validationResult = '';
			}
			else
			{
				validationResult += '\n';
			}			
			validationResult += ' * ' + result;
		}
	}

	if( validationResult != null )
	{
		alert('Please Correct the Following Error(s):\n\n'
				+ validationResult);
		return;
	}
	if( target != null )
	{
		document.forms.mainForm.target = target;
		document.forms.mainForm._target.value = target;
	}		
	document.forms.mainForm.submit();
	document.forms.mainForm.target = '';
	document.forms.mainForm._target.value = '';
}

function WComponent_getWindowGeometry()
{
	var myWidth = 0, myHeight = 0;
	if( typeof( window.innerWidth ) == 'number' ) 
	{
		//Non-IE
		myWidth = window.innerWidth; 
		myHeight = window.innerHeight;
	}
	else if( document.documentElement &&
		( document.documentElement.clientWidth || document.documentElement.clientHeight ) ) 
   	{
	    //IE 6+ in 'standards compliant mode'
	    myWidth = document.documentElement.clientWidth;
	    myHeight = document.documentElement.clientHeight;
	}
	else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) ) 
	{
	    //IE 4 compatible
    	myWidth = document.body.clientWidth;
	    myHeight = document.body.clientHeight;
	}
	
	var result = new Array(myWidth,myHeight);
	return result;
}

function WComponent_trim(sString) 
{
	while (sString.substring(0,1) == ' ')
	{
		sString = sString.substring(1, sString.length);
	}
	while (sString.substring(sString.length-1, sString.length) == ' ')
	{
		sString = sString.substring(0,sString.length-1);
	}
	return sString;
}

function WTabBox_onClick(fieldName,index)
{
	document.forms.mainForm.elements[fieldName].value = index;
	WComponent_submit(false,null);
	document.forms.mainForm.elements[fieldName].value = '';
}

function WTextBox_setValue(fieldName,value)
{
	document.forms.mainForm.elements[fieldName].value = value;
}

function WTextBox_checkRequired(validate,fieldName)
{
	if( validate )
	{
		var value = document.forms.mainForm.elements[fieldName].value;
		if( WComponent_trim( value ) == '' )
		{
			return "Value is required for the field XXX";
		}
	}
	return null;
}

function WButton_onClick(fieldName,frame,validate,confirmation)
{
	if( confirmation != null )
	{
		var result = confirm(confirmation);
		if( ! result )
		{
			return;
		}
	}
	document.forms.mainForm.elements[fieldName].value = '1';	
	WComponent_submit(validate,frame);
	document.forms.mainForm.elements[fieldName].value = '';	
}

function WCheckBox_onClick(fieldName)
{
	document.forms.mainForm.elements[fieldName].value = '1';
	WComponent_submit(false,null);
	document.forms.mainForm.elements[fieldName].value = '';
}

function WGrid_onClick(rowField,row,colField,col,frame,validate)
{
	document.forms.mainForm.elements[rowField].value = row;
	document.forms.mainForm.elements[colField].value = col;
	WComponent_submit(validate,frame);
	document.forms.mainForm.elements[rowField].value = '';
	document.forms.mainForm.elements[colField].value = '';
}

function WDateBox_onNow(field,format)
{
	var now = new Date();
	var nowString = WDateBox_format(now,format);
	document.forms.mainForm.elements[field].value = nowString;
}

function WDateBox_onMidnight(field,format)
{
	var midnight = new Date();
	midnight.setHours(0);
	midnight.setMinutes(0);
	midnight.setSeconds(0);
	var midnightString = WDateBox_format(midnight,format);
	document.forms.mainForm.elements[field].value = midnightString;
}

function WDateBox_format(date,format)
{
	var result = '';
	while( format.length > 0 )
	{
		if( format.indexOf("MM") == 0 )
		{
			result += WDateBox_padd( date.getMonth()+1 );	
			format = format.substring(2);
		}
		else if( format.indexOf("dd") == 0 )
		{
			result += WDateBox_padd( date.getDate() );	
			format = format.substring(2);
		}
		else if( format.indexOf("yy") == 0 )
		{
			result += WDateBox_padd( date.getFullYear() - 2000 );	
			format = format.substring(2);
		}
		else if( format.indexOf("HH") == 0 )
		{
			result += WDateBox_padd( date.getHours() );	
			format = format.substring(2);
		}
		else if( format.indexOf("mm") == 0 )
		{
			result += WDateBox_padd( date.getMinutes() );	
			format = format.substring(2);
		}
		else if( format.indexOf("ss") == 0 )
		{
			result += WDateBox_padd( date.getSeconds() );	
			format = format.substring(2);
		}
		else
		{
			result += format.substring(0,1);
			format = format.substring(1);	
		}
	}
	return result;
}

function WDateBox_padd(value)
{
	if( value < 10 )
	{
		return '0'+value;
	}
	return ''+value;
}

function WPageBar_onClick(fieldName,fieldValue,frame)
{
	document.forms.mainForm.elements[fieldName].value = fieldValue;
	WComponent_submit(true,frame);
	document.forms.mainForm.elements[fieldName].value = '';
}

function WProgress_report(fieldName,text)
{
	var div = document.getElementById(fieldName);
	div.innerHTML += text+"<br>";
}

function WProgress_refresh()
{
	WWindow_refresh();
}

function WProgress_show(tableName,popupWidth,popupHeight)
{
	var geometry = WComponent_getWindowGeometry();	
	var myWidth = geometry[0];
	var myHeight = geometry[1];

	var div = document.getElementById(tableName);	
	if( div == null )
	{
		WComponent_error('Unable to find table ['+tableName+'] to display progress.');
		return;
	}
	div.style.left = (myWidth - popupWidth)/2 + "px";
	div.style.top = (myHeight - popupHeight)/2 + "px";
	div.style.width = popupWidth+"px";
	div.style.height = popupHeight+"px";
	div.style.display = "";
}

function WComboBox_onChange(field,submit,submitIndicatorField)
{
	var selectedId = document.forms.mainForm.elements[field].value;
	
	for(var i=0;;i++)
	{
		var table = document.getElementById( field + i );
		if( table == null )
		{
			break;
		}
		table.style.display = 'none';
	}

	var table = document.getElementById( field + selectedId );	
	if( table && table != null )
	{
		table.style.display = '';
	}
	
	if( submit )
	{
		document.forms.mainForm.elements[submitIndicatorField].value = "1";	
		WComponent_submit(false,null);		
		document.forms.mainForm.elements[submitIndicatorField].value = "";	
	}
}

function WMaximizer_maximize(id)
{
	var geometry = WComponent_getWindowGeometry();	
	var myWidth = geometry[0];
	var myHeight = geometry[1];

	var t = document.getElementById(id);
    t.style.position = 'absolute';
    t.style.top = '0px';
    t.style.left = '0px';
    t.style.width = myWidth;
    t.style.height = myHeight;
}

function WMaximizer_minimize(id,width,height)
{
	var t = document.getElementById(id);
    t.style.position = 'relative';
    t.style.top = '0px';
    t.style.left = '0px';
    t.style.width = width;
    t.style.height = height;
}

function WTree_onClick(fieldName,index)
{
	document.forms.mainForm.elements[fieldName].value = index;
	alert('set '+fieldName+' to '+index);
	WComponent_submit(true,null);
	document.forms.mainForm.elements[fieldName].value = '';
}

function WTree_flip(rowId)
{
	var doClose = WTree_isOpen(rowId);

	var trs = document.getElementsByTagName("tr");
	for(var i=0; i<trs.length; i++)
	{
		var tr = trs[i];
		if( tr.id.indexOf(rowId) == 0 
				&& tr.id != rowId )
		{
			if( WTree_getLevelDiff(rowId,tr.id) == 1 || doClose )
			{
				tr.style.display = doClose ? 'none' : '';
				WTree_setNode(tr.id,false,!doClose);
			}
		}
	}
	
	WTree_setNode(rowId,!doClose,true);
}

function WTree_isOpen(rowId)
{
	var a = document.getElementById(rowId+"a");
	if( a )
	{
		return a.href.indexOf('#-') >= 0;
	}
	return
	{
		return false;
	}
}

function WTree_setNode(rowId,isOpen,updateImage)
{
	var a = document.getElementById(rowId+"a");
	if( a )
	{
		a.href = isOpen ? '#-' : '#+';
	}
 
 	if( updateImage )
	{
		var img = document.getElementById(rowId+"img");
		if( img )
		{
			img.src = isOpen ? "WTree/minus.gif" : "WTree/plus.gif";
		}
	}
}

function WTree_getLevelDiff(parent,child)
{
	var diff = child.substring(parent.length);
	var cnt = 0;
	for(var i=0; i<diff.length; i++)
	{
		if( diff.charAt(i) == '_' )
		{
			cnt++;
		}
	}
//alert('diff: '+diff+'  cnt: '+cnt);	
	return cnt;
}


/* Shows provided message in the help box */
function WHelpBox_show(message)
{
	var div = document.getElementById("WHelpBox_div");
	if( div && div != null )
	{
		div.innerHTML = message;
	}
}